#include <urbi/uobject.hh>

class MyAdder: public urbi::UObject
{
  public:
	// The class must have a single constructor taking a string. 
    MyAdder(const std::string& str);
    int init();
 
   // Our variable. 
   urbi::UVar v; 
 
   // Our method. 
   double add (double); 
};


// the constructor defines what is available from Urbi 
MyAdder::MyAdder(const std::string& s)
 : urbi::UObject(s)  // required 
{
  // Bind the variable. 
  UBindVar (MyAdder, v); 
 
  // Bind the function. 
  UBindFunction (MyAdder, add); 

  UBindFunction(MyAdder, init);
};

int MyAdder::init()
{
  return 0;
};

 
double 
MyAdder::add (double rhs) 
{ 
  return ((double)v + rhs); 
}


UStart(MyAdder);
